//+------------------------------------------------------------------+
//|                                            luktom pipsometer.mq4 |
//|                                   luktom :: ukasz Tomaszkiewicz |
//|                                               http://luktom.biz/ |
//+------------------------------------------------------------------+
//|                                                                  |
//| Licencja dostpna pod adresem:                                   |
//| http://go.luktom.biz/licencja_wskazniki_darmowe                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "ukasz Tomaszkiewicz :: luktom"
#property link      "http://luktom.biz/"

#property indicator_chart_window

extern color colorPositions=SteelBlue;
extern color colorRest=Black;
extern bool  allSymbols=false;
extern bool position_intelligent = true;

extern int   rightColOffset=0;

int top = 0;



int init() {

   ObjectCreate("lpm_pips",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_pips",OBJPROP_CORNER,2);
   ObjectSetText("lpm_pips","pips",30);
   ObjectSet("lpm_pips",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_pips",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_pips",OBJPROP_YDISTANCE,35);
   
   ObjectCreate("lpm_value",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_value",OBJPROP_CORNER,2);
   ObjectSetText("lpm_value","value",18);
   ObjectSet("lpm_value",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_value",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_value",OBJPROP_YDISTANCE,75);
   
   ObjectCreate("lpm_pips_tosl",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_pips_tosl",OBJPROP_CORNER,2);
   ObjectSetText("lpm_pips_tosl","S",11);
   ObjectSet("lpm_pips_tosl",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_pips_tosl",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_pips_tosl",OBJPROP_YDISTANCE,20);
   
   ObjectCreate("lpm_pips_realized",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_pips_realized",OBJPROP_CORNER,2);
   ObjectSetText("lpm_pips_realized","R",11);
   ObjectSet("lpm_pips_realized",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_pips_realized",OBJPROP_XDISTANCE,rightColOffset+90);
   ObjectSet("lpm_pips_realized",OBJPROP_YDISTANCE,20); 
   
   ObjectCreate("lpm_value_tosl",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_value_tosl",OBJPROP_CORNER,2);
   ObjectSetText("lpm_value_tosl","VS",11);
   ObjectSet("lpm_value_tosl",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_value_tosl",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_value_tosl",OBJPROP_YDISTANCE,5);

   ObjectCreate("lpm_value_realized",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_value_realized",OBJPROP_CORNER,2);
   ObjectSetText("lpm_value_realized","VR",11);
   ObjectSet("lpm_value_realized",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_value_realized",OBJPROP_XDISTANCE,rightColOffset+90);
   ObjectSet("lpm_value_realized",OBJPROP_YDISTANCE,5); 

   ObjectCreate("lpm_longlabel",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_longlabel",OBJPROP_CORNER,2);
   ObjectSetText("lpm_longlabel","Long",11);
   ObjectSet("lpm_longlabel",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_longlabel",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_longlabel",OBJPROP_YDISTANCE,125);

   ObjectCreate("lpm_shortlabel",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_shortlabel",OBJPROP_CORNER,2);
   ObjectSetText("lpm_shortlabel","Short",11);
   ObjectSet("lpm_shortlabel",OBJPROP_COLOR,colorRest);
   ObjectSet("lpm_shortlabel",OBJPROP_XDISTANCE,20);
   ObjectSet("lpm_shortlabel",OBJPROP_YDISTANCE,105);

   ObjectCreate("lpm_long",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_long",OBJPROP_CORNER,2);
   ObjectSetText("lpm_long","L",11);
   ObjectSet("lpm_long",OBJPROP_COLOR,colorPositions);
   ObjectSet("lpm_long",OBJPROP_XDISTANCE,65);
   ObjectSet("lpm_long",OBJPROP_YDISTANCE,125);

   ObjectCreate("lpm_short",OBJ_LABEL,0,0,0);
   ObjectSet("lpm_short",OBJPROP_CORNER,2);
   ObjectSetText("lpm_short","S",11);
   ObjectSet("lpm_short",OBJPROP_COLOR,colorPositions);
   ObjectSet("lpm_short",OBJPROP_XDISTANCE,65);
   ObjectSet("lpm_short",OBJPROP_YDISTANCE,105);

   start();
   
   return(0);
}

int deinit() {
   ObjectDelete("lpm_pips");
   ObjectDelete("lpm_value");
   ObjectDelete("lpm_pips_tosl");
   ObjectDelete("lpm_value_tosl");
   ObjectDelete("lpm_pips_realized");
   ObjectDelete("lpm_value_realized");
   ObjectDelete("lpm_long");
   ObjectDelete("lpm_short");   
   ObjectDelete("lpm_longlabel");
   ObjectDelete("lpm_shortlabel");
   return(0);
}

int start() {
   if(position_intelligent)
      setPos();
   double valueL;
   double valueS;
//   ObjectSetText("lpm_short",sign(valueS)+DoubleToStr(MathAbs(valueS),2));
//   ObjectSetText("lpm_long",sign(valueL)+DoubleToStr(MathAbs(valueL),2));
   
   ObjectSetText("lpm_short",DoubleToStr(countOrders(OP_SELL,allSymbols),0));
   ObjectSetText("lpm_long",DoubleToStr(countOrders(OP_BUY,allSymbols),0));
   
   double profit;
   
   double sl,vsl;
   calcProfit(profit,valueL,valueS,sl,vsl,allSymbols);
   
   ObjectSetText("lpm_value",sign(valueL + valueS)+DoubleToStr(MathAbs(valueL + valueS),2));
   ObjectSetText("lpm_pips",sign(profit)+DoubleToStr(MathAbs(profit),0));
   ObjectSetText("lpm_pips_tosl",sign(sl)+DoubleToStr(MathAbs(sl),0));
   ObjectSetText("lpm_value_tosl",sign(sl)+DoubleToStr(MathAbs(vsl),2));

   double realized,vrealized;
   calcRealized(realized,vrealized,allSymbols);
   
   ObjectSetText("lpm_pips_realized",sign(realized)+DoubleToStr(MathAbs(realized),0));
   ObjectSetText("lpm_value_realized",sign(realized)+DoubleToStr(MathAbs(vrealized),2));
   

   return(0);
}

int setPos(){
   int i,
       pos=0,
       shift;
   double price;
   shift = WindowFirstVisibleBar()*0.95;
   price = (High[shift] + Low[shift])/2;
   
   if(WindowPriceMax() - price > price - WindowPriceMin() )
      pos = 0;
   else
      pos = 2;
      
   for(i=0;i<ObjectsTotal();i++){
      if(StringSubstr(ObjectName(i),0,3) == "lpm" ){
         ObjectSet(ObjectName(i),OBJPROP_CORNER,pos);
      }
   
   
   }
   
   
   if( pos == 0 ){
      top=20;
      ObjectSet("lpm_pips",OBJPROP_YDISTANCE,35+top);
      ObjectSet("lpm_value",OBJPROP_YDISTANCE,75+top);
      ObjectSet("lpm_pips_tosl",OBJPROP_YDISTANCE,20+top);  
      ObjectSet("lpm_pips_realized",OBJPROP_YDISTANCE,20+top); 
      ObjectSet("lpm_value_tosl",OBJPROP_YDISTANCE,5+top);
      ObjectSet("lpm_value_realized",OBJPROP_YDISTANCE,5+top); 
      ObjectSet("lpm_longlabel",OBJPROP_YDISTANCE,125+top);
      ObjectSet("lpm_shortlabel",OBJPROP_YDISTANCE,105+top);
      ObjectSet("lpm_long",OBJPROP_YDISTANCE,125+top);
      ObjectSet("lpm_short",OBJPROP_YDISTANCE,105+top);
   }
}

void calcRealized(double& out, double& vout, bool allSymbols=false) {

   double profit=0,vprofit=0;
   double p=0;   
      
   for(int i=0;i<OrdersHistoryTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) {
     
     if(allSymbols || OrderSymbol()==Symbol()) {
     
      if(OrderCloseTime()<StrToTime("0:00")) {
       continue;
      }
      
      p=0;
      
      if(OrderType()==OP_BUY) {
       p=(OrderClosePrice()-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT);
      }
      
      if(OrderType()==OP_SELL) {
       p=(OrderOpenPrice()-OrderClosePrice())/MarketInfo(OrderSymbol(),MODE_POINT);
      }
      
      profit+=p;
      vprofit+=OrderProfit();
      vprofit+=OrderSwap();
      vprofit+=OrderCommission();
     
     }
    }
   }

   out=profit;
   vout=vprofit;

}

double calcProfit(double& out, double& valueoutLong, double& valueoutShort, double& outsl, double& voutsl, bool allSymbols=false) {

   double profit=0,vprofit=0,valueLong=0, valueShort=0;
   double p=0;
   double sl=0;
   double s=0;
     
   double tv=MarketInfo(Symbol(),MODE_TICKVALUE);
      
   for(int i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     
     if(allSymbols || OrderSymbol()==Symbol()) {
      
      p=0;
      s=0;
      
      if(OrderType()==OP_BUY) {
       p=(MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT);
       valueLong+=OrderProfit()+OrderCommission()+OrderSwap();
       if(OrderStopLoss()>0) {
        s=(OrderStopLoss()-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT);
       }
      }
      
      if(OrderType()==OP_SELL) {
       p=(OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT);
       valueShort+=OrderProfit()+OrderCommission()+OrderSwap();
       if(OrderStopLoss()>0) {
        s=(OrderOpenPrice()-OrderStopLoss())/MarketInfo(OrderSymbol(),MODE_POINT);
       }
      }
      
      sl+=s;
      profit+=p;
      vprofit+=s*tv*OrderLots();
      
     }
    }
   }
   
   valueoutLong=valueLong;
   valueoutShort=valueShort;
   out=profit;
   outsl=sl;
   voutsl=vprofit;
   
}

int countOrders(int oType,bool allSymbols=false) {

   int count=0;
 
   for(int i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     if(allSymbols || OrderSymbol()==Symbol()) {
      if(OrderType()==oType || oType<0) {
       count++;
      }
     }
    }
   }
   
   return(count);
 
}

string sign(double value) {
 
   if(value>0) {
    return("+");
   }
 
   if(value<0) {
    return("-");
   }

}




